Subject: [apps-discuss] Link rel uniqueness

From: Jan Algermissen <[email-masked]>
Date: Sun, 21 Oct 2012 00:33:02 +0200

Hi,

I am seeking a clarification ragarding link rel uniqueness in http://tools.ietf.org/html/rfc5988

AFAIU the required uniqueness of rel is 'per header' and thus, the following HTTP response headers in a single response would be valid according to RFC 5988:

Link: </a>; rel="describedBy"
Link: </b>; rel="describedBy"

Correct?

Jan

---

From: "Paul E. Jones" <[email-masked]>
Date: Sat, 20 Oct 2012 18:38:37 -0400

Jan,

It's quite common in HTML documents to have multiple <link> headers with the
same "rel" value pointing to different information, such as including
multiple CSS documents.

That said, what would a browser do if it sees multiple <link> relations for
a shortcut icon?

Perhaps the answer to your question is "it depends" :-)

Paul

> -----Original Message-----
> From: [email-masked] [mailto:apps-discuss-
> [email-masked]] On Behalf Of Jan Algermissen
> Sent: Saturday, October 20, 2012 6:33 PM
> To: IETF Apps Discuss
> Subject: [apps-discuss] Link rel uniqueness
> 
> Hi,
> 
> AFAIU the required uniqueness of rel is 'per header' and thus, the
> following HTTP response headers in a single response would be valid
> according to RFC 5988:
> 
> 
> _______________________________________________
> apps-discuss mailing list
> [email-masked]
> https://www.ietf.org/mailman/listinfo/apps-discuss

---

From: Mark Nottingham <[email-masked]>
Date: Sun, 21 Oct 2012 14:52:00 +1100

Hi Jan,

What's the specific requirement you're referring to?

Semantically, in ANY HTTP header defined using the "," list production, the following are equivalent:

Foo: 1
Foo: 2

and

Foo: 1, 2

Regards,

--
Mark Nottingham   http://www.mnot.net/

---

From: Jan Algermissen <[email-masked]>
Date: Sun, 21 Oct 2012 09:49:33 +0200

> What's the specific requirement you're referring to?

Section 5.3.:

"The relation type of a link is conveyed in the "rel" parameter's
   value.  The "rel" parameter MUST NOT appear more than once in a given
   link-value; occurrences after the first MUST be ignored by parsers."

I was unsure what the link-value refers to but from what you write below I understand that it refers to the combination of all header values of the same name.

That would then mean that parsers, when seeing

>> Link: </b>; rel="describedBy"

would, per 5.3., have to produce only

>> Link: </a>; rel="describedBy"

(ignoring the Link to /b)

Correct?

P.S. I find that a bit counter intuitive. Given that further links might occur elsewhere in the entity.

Jan

---

From: Mark Nottingham <[email-masked]>
Date: Sun, 21 Oct 2012 18:51:03 +1100

No. link-value is the syntactic construct of *one* link; see the ABNF. There can be multiple links with the same target; this is just saying that there can only be one "rel" parameter on each link.

Cheers,